{OEINDEX: Acquisition des coordonnes au clavier}
unit Coordon;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, Buttons, oemath;

type
  Tfcoordon = class(TForm)
    StringGrid1: TStringGrid;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure initialisation(Sender: TObject);
    procedure exit(Sender: TObject);
    procedure abandon(Sender: TObject);
    procedure verif_frappe(Sender: TObject);
    procedure onselect(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure effacement(Sender: TObject);
    procedure peint_cellule1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);

  private
    { Dclarations private }
  public
    { Dclarations public }
  end;

procedure verification ;

var
  fcoordon: Tfcoordon;
  ligne:integer;

implementation

uses Affivec2, Calcul, mainmenu;

var
  no_ligne : integer;

{$R *.DFM}

procedure relit_StringGrid1;
//--------------------------
var
  i,ier     : integer;
  s         : string;
  xx,yy     : real;
begin
  with fcoordon.stringGrid1 do begin
    nobs:=0;
    for i:=1 to 10 do begin
      s:=trim(cells[1,i]);
      if (cells[1,i] = '') and (cells[2,i] = '')then break;
      s:=trim(cells[1,i]);
      val(s,xx,ier);
      s:=trim(cells[2,i]);
      val(s,yy,ier);
      nobs:=nobs+1;
      xobs[nobs]:=xx;
      yobs[nobs]:=yy;
      cells[0,i]:=IntToStr(nobs);
    end;
  end;
end;

procedure ecrit_StringGrid1;
//--------------------------
var
  i,ier     : integer;
  s         : string;
  xx,yy     : real;
begin
  with fcoordon.stringGrid1 do begin
     for i:=1 to nobs do begin
      str(i:3,s);
      cells[0,i]:=s;
      str(xobs[i]:6:2,s);
      cells[1,i]:=s;
      str(yobs[i]:6:2,s);
      cells[2,i]:=s;
    end;
  end;
end;

//Initialisation: criture des titres des colonnes et lignes
procedure Tfcoordon.initialisation(Sender: TObject);{
----------------------------------------------------}
var
  i      : integer;
  s      : string;
begin
  StringGrid1.cells[0,0]:='  Nb.';
  StringGrid1.cells[1,0]:=' X(Cm)';
  StringGrid1.cells[2,0]:=' Y(Cm)';
  for i:=1 to 10 do begin
    str(i:2,s);
    StringGrid1.cells[0,i]:=s;
    s:='';
    StringGrid1.cells[1,i]:=s;
    StringGrid1.cells[2,i]:=s;
  end;

  {Acquisition des coordonnes au clavier}
  if(type_coordon = 0) then begin
    fcoordon.caption:='Acquisition of the coordinates';
  end;

  {Mofification des coordonnes}
  if(type_coordon = -1) then begin
    fcoordon.caption:='Modification of the coordinates';
    ecrit_StringGrid1;
  end;

end;

{Sortie, mise en tableau et criture en fichier}
procedure Tfcoordon.exit(Sender: TObject);{
------------------------------------------}
var
  i,j,ier                     : integer;
  s,s1                        : string;
  sortie{,ftemp}              : TextFile;
  xx,yy                       : single;
  w                           : word;
begin
  SaveDialog1.filterIndex:=1;
  if SaveDialog1.execute then s:=SaveDialog1.filename;

  if (length(s) > 0)then begin
    if (pos('.coo',s)=0)then s:=s+'.coo';
    if FileExists(s) then begin
      w:=messageDlg('This file already exists. Do you want to continue?',
      mtConfirmation,mbYesNoCancel,0);
      if (w = mrNo) or (w = mrAbort) then close;
    end;
    relit_stringgrid1;
    nom_fichier_coord:=s;
    AssignFile(sortie,nom_fichier_coord);
    ReWrite(sortie);
    for i:=1 to nobs do begin
      writeln(sortie,xobs[i]:10:5,yobs[i]:10:5);
    end;
    closeFile(sortie);
    type_coordon:=1;

//on rcrit stringGrid1 dans la fentre principale
    foemenu.panel2.visible:=true;
    with foemenu.StringGrid1 do begin
       for i:=1 to 10 do begin
         s:='';
         StringGrid1.cells[0,i]:=s;
         StringGrid1.cells[1,i]:=s;
         StringGrid1.cells[2,i]:=s;
      end;
      for i:=1 to nobs do begin
        str(i:2,s1);
        cells[0,i]:=s1;
        s1:='';
        str(xobs[i]:6:2,s1);
        Cells[1,i]:=s1;
        str(yobs[i]:6:2,s1);
        Cells[2,i]:=s1;
        Cells[3,i]:='';
      end;
      if (nobs < 10)then begin
        for i:=nobs+1 to 10 do
        for j:=1 to 3 do stringgrid1.cells[j,i]:='';
      end;
    end;
    //fcalcul.visible:=true;
  end;
  close;
end;

{Abandon}
procedure Tfcoordon.abandon(Sender: TObject);{
---------------------------------------------}
begin
  nom_fichier_coord:='';
  close;
end;

{Lecture et vrification erreurs de frappe (sortie de champ)}
procedure Tfcoordon.verif_frappe(Sender: TObject);{
---------------------------------------------------}
begin
  verification ;
end;

procedure verification ;{
------------------------}
var
  i,{j,}ier      : integer;
  s,s2         : string;
  xx,yy        : single;
begin

  for i:=1 to 10 do begin
    s:=trim(fcoordon.StringGrid1.Cells[1,i]);
    add_zero(s);
    if(length(s) = 0)then xx:=0;
    if(length(s) <> 0)then begin
      val(s,xx,ier);
      if(ier <> 0)then begin
        str(i:2,s2);
        s:='Type error (column 1, row'+ s2+')';
        Erreur(s);
        exit;
      end;
    end;
    s:=trim(fcoordon.StringGrid1.Cells[2,i]);
    add_zero(s);
    if(length(s) = 0)then yy:=0;
    if(length(s) <> 0)then begin
      val(s,yy,ier);
      if(ier <> 0)then begin
        str(i:2,s2);
        s:='Type error at column 2 and row'+ s2;
        Erreur(s);
        exit;
      end;
    end;
  end;

end;

procedure Tfcoordon.onselect(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//------------------------------------------------------------
begin
  no_ligne:=row;
//  if (col = 1) then relit_stringGrid1;
end;

procedure Tfcoordon.effacement(Sender: TObject);
//----------------------------------------------
var
  i,j,ier            : integer;
  xx,yy              : real;
  s                  : string;
begin
 with StringGrid1 do begin
    for i:=0 to 2 do cells[i,no_ligne]:='';
    for i:=no_ligne to nobs-1 do begin
         for j:=0 to 2 do Cells[j,i]:=cells[j,i+1];
         cells[0,i]:=intToStr(i);
         xobs[i]:=xobs[i+1];
         yobs[i]:=yobs[i+1];
    end;
    for j:=0 to 2 do stringGrid1.Cells[j,nobs]:='';
    nobs:=nobs-1;
    Ecrit_stringGrid1;
 end;

end;

procedure Tfcoordon.peint_cellule1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//---------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
  s:=stringgrid1.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

end.
