unit mainellipse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,  clipbrd, ExtCtrls, Menus, oemath;

type
  Tffitellipse = class(TForm)
    Image1: TImage;
    MainMenu1: TMainMenu;
    fichier: TMenuItem;
    Fit: TMenuItem;
    pointe: TMenuItem;
    sauvegarde: TMenuItem;
    SaveDialog1: TSaveDialog;
    Image2: TImage;
    retour: TMenuItem;
    Panel1: TPanel;
    procedure sortie(Sender: TObject);
    procedure initialisation_fiche(Sender: TObject);
    procedure croix_mousedown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lancement_intpo(Sender: TObject);
    procedure ecriture_pos_curseur(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure sauve_image(Sender: TObject);
    procedure Pointe_origine(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  ffitellipse: Tffitellipse;
  flag_click                               : boolean;

implementation

{$R *.DFM}

type
  tab_reel_dix                             = array[1..48] of single;
  tab_reel_cinq                            = array[1..5] of single;
var
  n_points                                 : integer;
  xp,yp                                    : tab_reel_dix;
  par                                      : tab_reel_cinq;

  {Click point de croisement avec zoom}
  drapeau,nb_ellipses                      : integer;
  tache_x,tache_y                          : integer;

{Fit d'une forme quadratique: DLL Fortran}
procedure intpo( xp,yp : tab_reel_dix; var par : tab_reel_cinq);
                far;stdcall;external 'intpo.dll' index 1;

{Rsolution quation du second degr}
procedure equa_second_deg(a,b,c : real; var x1,x2 :real; var ier : integer);
{---------------------------------------------------------------------------}
var
   delta,den          : real;
begin
  if (abs(a) < 0.000000001) then begin
    x1:=-c/b;
    x2:=x1;
    ier:=-1;
    exit;
  end;
  delta:=b*b-4*a*c;
  if (abs(delta) < 0.000000001) then begin
    x1:=-b/(2*a);
    x2:=1;
    ier:=-1;
    exit;
  end;
  if (delta < 0)then begin
    x1:=0;
    x2:=0;
    ier:=1;
    exit;
  end;
  if (delta > 0)then begin
    delta:=sqrt(delta);
    den:=2*a;
    x1:=(-b+delta)/den;
    x2:=(-b-delta)/den;
    ier:=0;
  end;

end;

{calcul de y1 et y2 connaissant x}
procedure calc_y(x:real; var y1,y2:real; var ier : integer);{
------------------------------------------------------------}
var
  a,b,c : real;
begin
  a:=par[2];
  b:=par[3]*x+par[5];
  c:=par[1]*x*x+par[4]*x-1;
  equa_second_deg(a,b,c,y1,y2,ier);
end;

{calcul de x1 et x2 connaissant y}
procedure calc_x(y:real; var x1,x2:real; var ier : integer);{
-----------------------------------------------------------}
var
  a,b,c : real;
begin
  a:=par[1];
  b:=par[3]*y+par[4];
  c:=par[2]*y*y+par[5]*y-1;
  equa_second_deg(a,b,c,x1,x2,ier);
end;

procedure Tffitellipse.sortie(Sender: TObject);{
-----------------------------------------}
begin
  image1.Picture.LoadFromFile(nom_fichier_image);
  ClipBoard.assign(image1.Picture);
  close;
end;

{Rappel du presse-papier pour effacer}
procedure gomme_ellipse;{
------------------------}
begin
     ffitellipse.image1.picture.Assign(ClipBoard);
end;

{Cration ou reset fiche}
procedure Tffitellipse.initialisation_fiche(Sender: TObject);{
-------------------------------------------------}
var
     i   : integer;
begin
   if (nb_pixel_cm = 0)then begin
     erreur('First determine the scale!');
     close;
     exit;
   end;
   hauteur_image:=round(hauteur*nb_pixel_cm);
   largeur_image:=round(largeur*nb_pixel_cm);
   image1.picture.assign(clipboard);
   image2.visible:=false;
   pointe.enabled:=false;
   flag_click:=true;
   drapeau:=1;
   nb_ellipses:=0;
   panel1.caption:=
   'click on some points (N>6) on an ellipse zone,'+
   'then click on Fit to launch the fir';
   n_points:=0;
   for i:=1 to 48 do begin
       xp[i]:=0;
       yp[i]:=0;
   end;
end;

{Evnement OnMouseDown}
procedure Tffitellipse.croix_mousedown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);{
----------------------------------------------------------------------}
var
  i,j                                : integer;
  s,s1                               : string;
begin
  if flag_click then begin
    with image1.canvas do begin
      moveto(x-4,y-4);
      lineto(x+4,y+4);
      moveto(x+4,y-4);
      lineto(x-4,y+4);
      moveto(x-4,y);
      lineto(x+4,y);
      moveto(x,y-4);
      lineto(x,y+4);
      n_points:=n_points+1;
      xp[n_points]:=x;
      yp[n_points]:=y;
      xp[n_points]:=xp[n_points]/10;
      yp[n_points]:=yp[n_points]/10;
      exit;
    end;
  end;
  if not flag_click then begin
    if (drapeau = 1) then begin
      drapeau:=-1;

      {Apparition de l'image zoom}
      image2.width:=40;
      image2.height:=40;
      image2.visible:=false;

      {On copie un carr de 40X40 de l'image1 dans l'image2}
      image2.canvas.copyrect
      (rect(0,0,40,40),image1.canvas,rect(x-20,y-20,x+20,y+20));

      {On copie image2 dans image1 centr sur x,y sur un carr de 80X80}
      image1.canvas.stretchDraw(rect(x-40,y-40,x+40,y+40),
      image2.picture.graphic);

      {Encadrement de l'image zoom}
      image1.canvas.moveto(x-41,y-41);
      image1.canvas.lineto(x+41,y-41);
      image1.canvas.lineto(x+41,y+41);
      image1.canvas.lineto(x-41,y+41);
      image1.canvas.lineto(x-41,y-41);
      tache_x:=x;
      tache_y:=y;
      panel1.caption:='Click on the cross of the red lines';
      exit;
    end;
    if(drapeau = -1)then begin   {Click dans l'image zoom}
      drapeau:=1;
      i:=(tache_x+x) div 2;
      j:=(tache_y+y) div 2;
      x_origine:=i;
      y_origine:=j;
      gomme_ellipse;
      canvas.pen.color:=clgreen;
      with image1.canvas do begin
        pen.color:=clgreen;
        moveto(i-4,j-4);
        lineto(i+4,j+4);
        moveto(i+4,j-4);
        lineto(i-4,j+4);
        moveto(i-7,j);
        lineto(i+7,j);
        moveto(i,j-7);
        lineto(i,j+7);
      end;
      str(x_origine:4,s);
      str(y_origine:4,s1);
      s:='orgine: '+s+s1;
      canvas.TextOut(700,400,s);
      canvas.pen.color:=clblack;
      flag_click:=true;
      exit;
    end;
  end;
end;

{Option Fit. Fit de l'ellipse}
procedure Tffitellipse.lancement_intpo(Sender: TObject);{
--------------------------------------------------}
var
  ix,iy,i,ier                   : integer;
  nomf                          : TextFile;
  y1,y2,x1,x2,xx,yy             : real;
begin

  assignFile(nomf,'intpo.inp');
  rewrite(nomf);
  for i:=1 to n_points do  writeln(nomf,xp[i]:8:2,yp[i]:8:2);
  closeFile(nomf);

  if(n_points > 5)then begin
    intpo(xp,yp,par);

    {Trac de l'ellipse y=f(x)}
    for i:=1 to largeur_image do begin
      xx:=i*0.1;
      calc_y(xx,y1,y2,ier);
      if(ier = 1)then continue;
      ix:=round(xx*10);
      iy:=round(y1*10);
      image1.canvas.pixels[ix,iy]:=clred;
      iy:=round(y2*10);
      image1.canvas.pixels[ix,iy]:=clred;
    end;


    {Trac de l'ellipse x=f(y)}
    for i:=1 to hauteur_image do begin
      yy:=i*0.1;
      calc_x(yy,x1,x2,ier);
      if(ier = 1)then continue;
      iy:=round(yy*10);
      ix:=round(x1*10);
      image1.canvas.pixels[ix,iy]:=clred;
      ix:=round(x2*10);
      image1.canvas.pixels[ix,iy]:=clred;
    end;

    nb_ellipses:=nb_ellipses+1;
    if(nb_ellipses > 1)then pointe.enabled:=true;

    {Reset des variables pour la lecture des ellipses suivantes}
    n_points:=0;
    for i:=1 to 48 do begin
       xp[i]:=0;
       yp[i]:=0;
    end;
  end;
end;

procedure Tffitellipse.ecriture_pos_curseur(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);{
  -----------------------------------------------------------------------}
var
   x_rect,y_rect            : integer;
   s,s1                     : string;
begin
  x_rect:=700;
  y_rect:=470;
  canvas.rectangle(x_rect,y_rect,x_rect+58,y_rect+23);
  str(x:4,s);
  str(y:4,s1);
  s:=s+s1;
  canvas.textout(x_rect+3,y_rect+5,s);
end;

{Option Menu Sauve Image}
procedure Tffitellipse.sauve_image(Sender: TObject);
{--------------------------------------------------}
var
   nom_fichier_sauve : string;
   w                 : word;
begin
   if SaveDialog1.execute then begin
     nom_fichier_sauve:=SaveDialog1.filename;
     if (pos('.',nom_fichier_sauve) = 0) then
     nom_fichier_sauve:=nom_fichier_sauve+'.bmp';
     if FileExists(nom_fichier_sauve) then begin
         //beep;
         w:=messageDlg('This file already exists. Do you want to continue?',
         mtConfirmation,mbYesNoCancel,0);
         if (w = mrNo) or (w = mrAbort) then exit;
     end;
     image1.picture.savetofile(nom_fichier_sauve);
   end;
end;

{Option pointe Origine}
procedure Tffitellipse.Pointe_origine(Sender: TObject);
{-----------------------------------------------------}
begin
  ClipBoard.assign(image1.Picture);
  flag_click:=false;
  panel1.caption:='Click near the center of the diagram';
  drapeau:=1;
end;

end.
