{
  TCommPortDriver demo
  v1.00 15/FEB/1997 First implementation
  v1.01 19/APR/1997 Some bug fixes (in the demo)
}

unit mdigital;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls,

  ComDrv32, Menus;

type
  TMainForm = class(TForm)
    CommPortDriver: TCommPortDriver;
    Panel1: TPanel;
    StatusBar: TStatusBar;
    QuitBtn: TButton;
    ComPortRG: TRadioGroup;
    BaudRateRG: TRadioGroup;
    DataBitsRG: TRadioGroup;
    ParityRG: TRadioGroup;
    HandshakingRG: TRadioGroup;
    RxMemo: TMemo;
    MainMenu1: TMainMenu;
    Configuration1: TMenuItem;
    Originedetermination1: TMenuItem;
    Coordinatesmeasurement1: TMenuItem;
    Quit1: TMenuItem;
    Panel2: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    Panel3: TPanel;
    procedure QuitBtnClick(Sender: TObject);
    procedure CommPortDriverReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure ConnectBtnClick(Sender: TObject);
    procedure DisconnectBtnClick(Sender: TObject);
    procedure BaudRateRGClick(Sender: TObject);
    procedure DataBitsRGClick(Sender: TObject);
    procedure ParityRGClick(Sender: TObject);
    procedure HandshakingRGClick(Sender: TObject);
    procedure ComPortRGClick(Sender: TObject);
    procedure ClrInMemoClick(Sender: TObject);
    procedure ClrOutMemoClick(Sender: TObject);
    procedure SetDTRBtnClick(Sender: TObject);
    procedure ClrDTRBtnClick(Sender: TObject);
    procedure SetRTSBtnClick(Sender: TObject);
    procedure ClrRTSBtnClick(Sender: TObject);
    procedure sortie_de_config(Sender: TObject);
    procedure initialisation(Sender: TObject);
    procedure initialisation_activation(Sender: TObject);
    procedure Configuration(Sender: TObject);
    procedure Sortie(Sender: TObject);
    procedure autorise_origine(Sender: TObject);
    procedure autorise_mesure(Sender: TObject);
  private
    procedure ApplyCommSettings;
  public
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
var
  espion                          : textfile;
  chaine                        : string;

  flag_mesure,flag_origine      : boolean;
  x_zero,y_zero                 : real;
  nb_mesures                    : integer;
  xorigine,yorigine             : array[1..10] of real;

  nobs                          : integer;
  xobs,yobs                     : array[1..10] of real;

procedure ecrit_fichier_config;{
-------------------------------}
var
  espion                                        : TextFile;
  com,baud_rate,data_bits,parity,handshaking  : integer;
begin
  assignFile(espion,'OrientExpress.cfg');
  rewrite(espion);
  with mainForm do begin
    com:=ComPortRG.ItemIndex;
    baud_rate:=BaudRateRG.ItemIndex;
    data_bits:=DataBitsRG.ItemIndex;
    parity:=parityRG.ItemIndex;
    handshaking:=HandshakingRG.ItemIndex;
  end;
  writeln(espion,com:5,baud_rate:5,data_bits:5,parity:5,handshaking:5);
  closefile(espion);
end;

procedure lecture_fichier_config;{
---------------------------------}
var
  espion                                        : TextFile;
  com,baud_rate,data_bits,parity,handshaking  : integer;
begin
  if fileExists('OrientExpress.cfg') then begin
    assignFile(espion,'OrientExpress.cfg');
    reset(espion);
    readln(espion,com,baud_rate,data_bits,parity,handshaking);
    closefile(espion);
    with mainForm do begin
      ComPortRG.ItemIndex:=com;
      BaudRateRG.ItemIndex:=baud_rate;
      DataBitsRG.ItemIndex:=data_bits;
      ParityRG.ItemIndex:=parity;
      HandshakingRG.ItemIndex:=handshaking;
    end;
  end else begin
     with mainForm do begin
       ComPortRG.ItemIndex:=0;
       BaudRateRG.ItemIndex:=5;
       DataBitsRG.ItemIndex:=3;
       ParityRG.ItemIndex:=0;
       HandshakingRG.ItemIndex:=1;
       ecrit_fichier_config;
     end;
  end;

end;

procedure TMainForm.QuitBtnClick(Sender: TObject);{
--------------------------------------------------}
begin
  Close;
end;

procedure erreur(s:string);{
---------------------------}
begin
   MessageDlg(s,mtWarning,[mbOK],0);
end;

procedure decode(var x,y:real; var no_bouton:integer);{
------------------------------------------------------}
var
  s,s1   : string;
  ier    : integer;
begin
  s:=chaine;
  s1:=copy(s,2,7);
  val(s1,x,ier);
  if (ier > 0)then begin
    erreur('Erreur sur dcodage de X');
    exit;
  end;
  x:=x/10000;

  s1:=copy(s,11,7);
  val(s1,y,ier);
  if (ier > 0)then begin
    erreur('Erreur sur dcodage de Y');
    exit;
  end;
  y:=y/10000;

  s1:=copy(s,19,2);
  if (s1[1] = '0')then s1[1]:=' ';
  no_bouton:=StrToInt(s1);
  if (ier > 0)then begin
    erreur('Erreur sur dcodage du numro de bouton');
    exit;
  end;

end;

procedure TMainForm.CommPortDriverReceiveData(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);{
  -----------------------------------------------------------}
var p            : pchar;
    x,y          : real;
    no_bouton,i  : integer;
    s,s1,s2,s3   : string;
    nomf         : TextFile;
begin
  p := DataPtr;
  while DataSize > 0 do
  begin
    case p^ of
      #13: // CR (entre)
{---------------------------------------------------------------------------}
        begin
          decode(x,y,no_bouton);

          // Dtermination de l'origine?
          if (flag_origine = true) and  (flag_mesure = false) then begin
            if (no_bouton = 16) then begin       // fin de mesure
              x_zero:=0;
              y_zero:=0;
              for i:=1 to nb_mesures do begin    // Moyenne
                x_zero:=x_zero+xorigine[i];
                y_zero:=y_zero+yorigine[i];
              end;
              x_zero:=x_zero/nb_mesures;
              y_zero:=y_zero/nb_mesures;
              str(x_zero:7:2,s1);
              edit1.text:=s1;
              str(y_zero:7:2,s1);
              rxmemo.clear;
              edit2.text:=s1;
              flag_origine:=false;
              flag_mesure:=false;
              nb_mesures:=0;
            end else if(no_bouton = 15) then begin  // Effacement de la mesure
              RxMemo.Lines.clear;
              nb_mesures:=nb_mesures-1;
              for i:=1 to nb_mesures do begin
                str(xorigine[i]:7:2,s1);
                str(yorigine[i]:7:2,s2);
                rxMemo.lines.add(IntToStr(i)+' '+s1+' '+s2);
              end;
            end else begin                        // Mesure bonne
              nb_mesures:=nb_mesures+1;
              xorigine[nb_mesures]:=x;
              yorigine[nb_mesures]:=y;
              str(xorigine[nb_mesures]:7:2,s1);
              str(yorigine[nb_mesures]:7:2,s2);
              rxMemo.lines.add(IntToStr(nb_mesures)+' '+s1+' '+s2);
            end;
          end;

          // Mesure des coordonnes?
          if (flag_origine = false) and  (flag_mesure = true) then begin
            if (no_bouton = 16) then begin        // Fin de mesure
              flag_origine:=false;
              flag_mesure:=false;
              nobs:=nb_mesures;
              nb_mesures:=0;
              SaveDialog1.filterIndex:=1;         // Sauvegarde des coordonnes
              if SaveDialog1.execute then s:=SaveDialog1.filename;
              if (pos(s,'.coo') = 0)then s:=s+'.coo';
              AssignFile(nomf,s);
              rewrite(nomf);
              for i:=1 to nobs do writeln(nomf,xobs[i]:8:2,yobs[i]:8:2);
              closeFile(nomf);
           end else if (no_bouton = 15) then begin//  Effacement de la mesure
              RxMemo.Lines.clear;
              nb_mesures:=nb_mesures-1;
              for i:=1 to nb_mesures do begin
                str(xobs[i]:7:2,s1);
                str(yobs[i]:7:2,s2);
                rxMemo.lines.add(IntToStr(i)+' '+s1+' '+s2);
              end;
            end else begin                         //  Mesure bonne
              nb_mesures:=nb_mesures+1;
              xobs[nb_mesures]:=x-x_zero;
              yobs[nb_mesures]:=y-y_zero;
              str(xobs[nb_mesures]:7:2,s1);
              str(yobs[nb_mesures]:7:2,s2);
              rxMemo.lines.add(IntToStr(nb_mesures)+' '+s1+' '+s2);
            end;
          end;

          {if (no_bouton = 16)then  closeFile(espion)}
          {else}
          writeln(espion,'X=',x:7:2,' Y=',y:7:2,' bouton:',no_bouton:1);
          chaine := '';
        end;
{-----------------------------------------------------------------------------}
      else // On ajoute les caractres
        chaine := chaine + p^;
    end;
    dec( DataSize );
    inc( p );
  end;
  RxMemo.Update;
end;

procedure TMainForm.ConnectBtnClick(Sender: TObject);{
-----------------------------------------------------}
begin
  // Apply settings
  ApplyCommSettings;
  // Connect
  if CommPortDriver.Connect then
  begin
    {ConnectBtn.Enabled := false;
    DisconnectBtn.Enabled := true;}
    StatusBar.SimpleText := 'Connected';
    {TxMemo.SetFocus;}
  end
  else // Error !
    begin
      StatusBar.SimpleText :=
      'Error: could not connect. Check COM port settings and try again.';
      MessageBeep( 0 );
    end;
end;

procedure TMainForm.DisconnectBtnClick(Sender: TObject);{
--------------------------------------------------------}
begin
  StatusBar.SimpleText := 'Disconnected';
  CommPortDriver.Disconnect;
  {DisconnectBtn.Enabled := false;
  ConnectBtn.Enabled := true;}
end;

procedure TMainForm.BaudRateRGClick(Sender: TObject);{
-----------------------------------------------------}
begin
  CommPortDriver.ComPortSpeed := TComPortBaudRate(BaudRateRG.ItemIndex+1);
end;

procedure TMainForm.DataBitsRGClick(Sender: TObject);{
------------------------------------------------------}
begin
  CommPortDriver.ComPortDataBits := TComPortDataBits(DataBitsRG.ItemIndex);
end;

procedure TMainForm.ParityRGClick(Sender: TObject);{
---------------------------------------------------}
begin
  CommPortDriver.ComPortParity := TComPortParity(ParityRG.ItemIndex);
end;

procedure TMainForm.HandshakingRGClick(Sender: TObject);{
--------------------------------------------------------}
begin
  case HandshakingRG.ItemIndex of
    0: // none
      begin
        CommPortDriver.ComPortHwHandshaking := hhNone;
        CommPortDriver.ComPortSwHandshaking := shNone;
      end;
    1: // RTS/CTS
      begin
        CommPortDriver.ComPortHwHandshaking := hhRTSCTS;
        CommPortDriver.ComPortSwHandshaking := shNone;
      end;
    2: // XON/XOFF
      begin
        CommPortDriver.ComPortHwHandshaking := hhNone;
        CommPortDriver.ComPortSwHandshaking := shXONXOFF;
      end;
    3: // RTS/CTS + XON/XOFF
      begin
        CommPortDriver.ComPortHwHandshaking := hhRTSCTS;
        CommPortDriver.ComPortSwHandshaking := shXONXOFF;
      end;
  end;
end;

procedure TMainForm.ComPortRGClick(Sender: TObject);{
-----------------------------------------------------}
begin
  // Apply com settings
  //ApplyCommSettings;
end;

procedure TMainForm.ApplyCommSettings;{
--------------------------------------}
var wasConnected: boolean;
begin
  wasConnected := CommPortDriver.Connected;
  // This change needs CommPortDriver not connected
  if wasConnected then
    DisconnectBtnClick( nil );

  CommPortDriver.ComPort := TComPortNumber(ord(ComPortRG.ItemIndex));
  BaudRateRGClick( nil );
  DataBitsRGClick( nil );
  ParityRGClick( nil );
  HandshakingRGClick( nil );

  // Reconnect
  if wasConnected then
    ConnectBtnClick( nil );
end;

procedure TMainForm.ClrInMemoClick(Sender: TObject);{
----------------------------------------------------}
begin
  RxMemo.Lines.Clear;
end;

procedure TMainForm.ClrOutMemoClick(Sender: TObject);{
-----------------------------------------------------}
begin
  {TxMemo.Lines.Clear;}
end;

procedure TMainForm.SetDTRBtnClick(Sender: TObject);{
----------------------------------------------------}
begin
  CommPortDriver.ToggleDTR( true );
end;

procedure TMainForm.ClrDTRBtnClick(Sender: TObject);{
-----------------------------------------------------}
begin
  CommPortDriver.ToggleDTR( false );
end;

procedure TMainForm.SetRTSBtnClick(Sender: TObject);{
----------------------------------------------------}
begin
  CommPortDriver.ToggleRTS( true );
end;

procedure TMainForm.ClrRTSBtnClick(Sender: TObject);{
----------------------------------------------------}
begin
  CommPortDriver.ToggleRTS( false );
end;

procedure TMainForm.sortie_de_config(Sender: TObject);{
------------------------------------------------------}
begin
   panel1.visible:=false;
   ecrit_fichier_config;
   ConnectBtnClick(Sender);
   rxmemo.visible:=true;
end;

procedure TMainForm.initialisation(Sender: TObject);{
----------------------------------------------------}
begin
  assignFile(espion,'espion.txt');
  rewrite(espion);
  ConnectBtnClick(Sender);
  rxmemo.left:=30;
  rxmemo.top:=20;
  panel1.left:=30;
  panel1.top:=20;
  flag_mesure:=false;
  flag_origine:=false;
  x_zero:=0;
  y_zero:=0;
end;

procedure TMainForm.initialisation_activation(Sender: TObject);{
---------------------------------------------------------------}
begin
  lecture_fichier_config;
  ConnectBtnClick(Sender);
end;

procedure TMainForm.Configuration(Sender: TObject);{
---------------------------------------------------}
begin
  DisconnectBtnClick(Sender);
  panel1.visible:=true;
  rxmemo.visible:=false;
end;

procedure TMainForm.Sortie(Sender: TObject);{
--------------------------------------------}
begin
  Closefile(espion);
  close;
end;

procedure TMainForm.autorise_origine(Sender: TObject);{
------------------------------------------------------}
begin
  flag_origine:=true;
  flag_mesure:=false;
  RxMemo.Lines.Clear;
  nb_mesures:=0;
  panel3.caption:='Origin determination';
end;

procedure TMainForm.autorise_mesure(Sender: TObject);{
-----------------------------------------------------}
begin
  if (x_zero > 0) and (y_zero > 0)then begin
    flag_origine:=false;
    flag_mesure:=true;
    RxMemo.Lines.Clear;
    nb_mesures:=0;
    panel3.caption:='Coordinates measurement';
  end else begin
    erreur('First determine the origin!');
  end;
end;

end.
