unit pstereo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  Tfpstereo = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure initialise(Sender: TObject);
    procedure retour(Sender: TObject);
    procedure retrace(Sender: TObject);
    procedure indexe(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fpstereo: Tfpstereo;

implementation

{$R *.DFM}
uses
  oemath;
var
  rstereo,echel                          : real;
  xo,yo,hmax,kmax,lmax                   : integer;

procedure dessin;{
-----------------}
var
  s                                                   : string;
  xp,yp,x3,y3,z3,som                                  : real;
  x,y,l,ih,ik,il                                      : integer;

  begin
   {Cercle de la projection et effacement}
   l:=round(rstereo*echel);
   with fpstereo do begin
     image1.canvas.pen.color:=clred;
     image1.canvas.ellipse(xo-l,yo-l,xo+l,yo+l);
     image1.canvas.pen.color:=clblack;

     {Eciture nom du fichier}
     image1.canvas.font.color:=clblack;
     s:=extractFileName(nom_fichier_donnees);
     image1.canvas.textout(10,2*round(rstereo*echel)+20,s);

     {croix}
     image1.canvas.moveto(xo-5,yo);
     image1.canvas.lineto(xo+5,yo);
     image1.canvas.moveto(xo,yo-5);
     image1.canvas.lineto(xo,yo+5);

     {Dessin des ples gnraux}
     for ih:=-hmax to hmax do begin
       for ik:=-kmax to kmax do begin
         for il:=-lmax to lmax do begin
           if(ih = 0) and (ik = 0) and (il = 0) then continue;
           if (systeme = 'H') and (bravais = 'R') and (((-ih+ik+il) mod 3) <> 0)
           then continue;
           x3:=r31[1,1]*ih+r31[1,2]*ik+r31[1,3]*il;
           y3:=r31[2,1]*ih+r31[2,2]*ik+r31[2,3]*il;
           z3:=r31[3,1]*ih+r31[3,2]*ik+r31[3,3]*il;
           som:=sqrt(x3*x3+y3*y3+z3*z3);
           x3:=x3/som;
           y3:=y3/som;
           z3:=z3/som;
           x3:=x3+1;
           if (x3 < 0.000001) then continue;
           xp:=rstereo*y3/x3;
           yp:=rstereo*z3/x3;
           if (sqrt(xp*xp+yp*yp) >= rstereo)then continue;
           x:=xo+round(xp*echel);
           y:=yo-round(yp*echel);
           image1.canvas.pen.color:=clblack;
           if (ih = 0) and (ik = 0)then image1.canvas.pen.color:=clblue;
           if (ik = 0) and (il = 0)then image1.canvas.pen.color:=clred;
           if (il = 0) and (ih = 0)then image1.canvas.pen.color:=clgreen;
           image1.canvas.ellipse(x-2,y-2,x+2,y+2) ;
         end;
       end;
     end;
   end;
 end;

procedure Tfpstereo.initialise(Sender: TObject);{
------------------------------------------------}
begin
  left:=0;top:=20;
  nb_pixel_cm:=0;
  echel:=25;
  rstereo:=10;
  xo:=round(rstereo*echel)+5;
  yo:=round(rstereo*echel)+5;
  hmax:=5;
  kmax:=5;
  lmax:=5;
  edit1.text:=inttostr(hmax);
  edit2.text:=inttostr(kmax);
  edit3.text:=inttostr(lmax);

  image1.canvas.brush.color:=clwhite;
  image1.canvas.rectangle (1,1,image1.width-1,image1.height-1);
  canvas.FloodFill
  (image1.width div 2,image1.height div 2,clblack,fsborder);
  dessin;
end;

procedure Tfpstereo.retour(Sender: TObject);
begin
  close;
end;

procedure Tfpstereo.retrace(Sender: TObject);{
---------------------------------------------}
var
  s                      : string;
  ier                    : integer;
begin
  s:=edit1.text;
  val(s,hmax,ier);
  if(ier > 0)then begin
    erreur('Read error');
    exit;
  end;
  s:=edit2.text;
  val(s,kmax,ier);
  if(ier > 0)then begin
    erreur('Read error');
    exit;
  end;
  s:=edit3.text;
  val(s,lmax,ier);
  if(ier > 0)then begin
    erreur('Read error');
    exit;
  end;
  dessin;
end;

procedure Tfpstereo.indexe(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);{
  ---------------------------------------------------------------}
var
  t,xx,yy,zz,xr,yr                      : real;
  i1,i2,i3,ier                          : integer;
  xyz,hkl                               : vecteur3;
  s,s1,s2,s3                            : string;
begin
    xr:=(x-xo)/echel;
    yr:=(yo-y)/echel;
    t:=2*rstereo*rstereo/(rstereo*rstereo+xr*xr+yr*yr);
    xx:=rstereo*(t-1);
    yy:=t*xr;
    zz:=t*yr;
    norm(xx,yy,zz);
    xyz[1]:=xx;
    xyz[2]:=yy;
    xyz[3]:=zz;
    trfo3(xyz,r13);
    indice(xyz,hkl,ier);
    if(ier = 0)then begin
      i1:= round(hkl[1]);
      i2:= round(hkl[2]);
      i3:= round(hkl[3]);
      str(i1,s1);
      str(i2,s2);
      str(i3,s3);
      s:=s1+s2+s3;
      image1.canvas.font.size:=8;
      image1.canvas.textout(x,y,s);
    end;
    if(ier <> 0) then image1.canvas.textout(x,y,'?');

 (*   t:=2*rstereo*rstereo/(rstereo*rstereo+xr*xr+yr*yr);
    xx:=rstereo*(t-1);
    yy:=t*xr;
    zz:=t*yr;
    norm(xx,yy,zz);
    xyz[1]:=xx;
    xyz[2]:=yy;
    xyz[3]:=zz;
    trfo3(xyz,r13);
    indice(xyz,hkl,ier);
    if(ier = 0)then begin
      i1:= round(hkl[1]);
      i2:= round(hkl[2]);
      i3:= round(hkl[3]);
      str(i1,s1);
      str(i2,s2);
      str(i3,s3);
      s:=s1+s2+s3;
      image1.canvas.font.size:=8;
      image1.canvas.textout(x,y,s);
    end;
    if(ier <> 0) then image1.canvas.textout(x,y,'?'); *)

 end;

end.
